.nocodes

ALL_IRQS 	= $1B		; Link port, Timer, ON key
APS_TIME 	= 25000		; About 3 minutes
MSG_PANE	= 48		; Lowest screen row of message pane text
CMD_PANE	= 58		; Screen row of command pane text

user_ram	= $8100		; 24320
psp		= $8103		; 16
prgm_start	= $8113		; 16109
os.lcd_mem	= $F000		; 768
os.console	= $F300		; 216

os_ram		= $E000
os.free			= os_ram + 0		; 1024		$E000
os.scrap		= os_ram + 1024		; 32		$E400
os.buffer		= os_ram + 1056		; 129		$E420
os.arg_count		= os_ram + 1185		; 1		$E4A1
os.arg_ptrs		= os_ram + 1186		; 128		$E4A2
os.contrast		= os_ram + 1314		; 1		$E522
os.aps_timer		= os_ram + 1315		; 2		$E523
os.checksum		= os_ram + 1317		; 2		$E525
os.status_flags		= os_ram + 1319		; 1		$E527
os.prev_key		= os_ram + 1320		; 1		$E528
os.free_mem_ptr		= os_ram + 1321		; 2		$E529
os.temp_num		= os_ram + 1323		; 2		$E52B
os.tempname		= os_ram + 1325		; 14		$E52D
os.extension		= os_ram + 1339		; 3		$E53B
os.name_len		= os_ram + 1342		; 1		$E53E
os.curpos_col		= os_ram + 1343		; 1		$E53F
os.curpos_row		= os_ram + 1344		; 1		$E540
os.exception_num	= os_ram + 1345		; 1		$E541
os.estack		= os_ram + 1346		; 2		$E542

; os.status_flags flag bits
calc_on		= 0	; 1 = calc is on
aps_on		= 1	; 1 = process APS timer in ISR
prgm_running	= 2	; 1 = program is running


; Program segment prefix
psp.flags	= psp + 0	;1 Program flags
psp.id		= psp + 1	;1 Magic number
psp.stack	= psp + 2	;2 Stack pointer
psp.restart	= psp + 4	;2 Restart vector
psp.title	= psp + 6	;2 Title pointer
psp.ehandler	= psp + 8	;2 Exception vector
psp.interrupt	= psp + 10	;2 Interrupt vector
psp.reserved	= psp + 12	;4 Unused

; psp.flags flag bits
show_title	= 0	; SET: Display the title and pause for 3 sec.
hold_screen	= 1	; SET: Wait for a key on exit
clear_enter	= 2	; SET: Clear screen on entry
clear_exit	= 3	; SET: Clear screen on exit

#define	bitmask(pos)	1<<(pos)
#define invmask(pos)	~(1<<(pos))
#define	lcd(row,col)	os.lcd_mem+((row)*12)+((col)/8)
#define lcd_busy	in a,(lcd_cmd_port)\ and $80\ jr nz, $-4
#define range_test(lower,upper,under,over)	cp lower\ jr c, under\ cp upper+1\ jr nc, over
#define	arg(elem)	os.arg_ptrs+((elem)*2)
#define	msb(val)	(val)>>8
#define	lsb(val)	(val)&$FF

#define	reset		RST 00H
#define	deref_hl	RST 08H
#define	cmp_hlde	RST 10H
#define	rowread		RST 18H
#define	offset_hl	RST 20H
#define	user_rst	RST 28H
#define	system		RST 30H
#define	irq		RST 38H

link_port		= $00
key_port		= $01
hw_port			= $02
irq_mask_port		= $03
irq_stat_port		= $04
flash_pageA_port	= $06
lcd_cmd_port		= $10
lcd_data_port		= $11

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; Key groups and bits for rowread
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
kg_arrows	=	$FE
kb_down		=	0
kb_left		=	1
kb_right	=	2
kb_up		=	3

kg_row1		=	$FD
kb_enter	=	0
kb_plus		=	1
kb_minus	=	2
kb_times	=	3
kb_obelus	=	4
kb_caret	=	5
kb_clear	=	6

kg_row2		=	$FB
kb_chs		=	0
kb_3		=	1
kb_6		=	2
kb_9		=	3
kb_rparen	=	4
kb_tan		=	5
kb_vars		=	6

kg_row3		=	$F7
kb_point	=	0
kb_2		=	1
kb_5		=	2
kb_8		=	3
kb_lparen	=	4
kb_cos		=	5
kb_prgm		=	6
kb_stat		=	7

kg_row4		=	$EF
kb_0		=	0
kb_1		=	1
kb_4		=	2
kb_7		=	3
kb_comma	=	4
kb_sin		=	5
kb_apps		=	6
kb_xt0n		=	7

kg_row5		=	$DF
kb_sto		=	1
kb_ln		=	2
kb_log		=	3
kb_square	=	4
kb_recip	=	5
kb_math		=	6
kb_alpha	=	7

kg_func		=	$BF
kb_f5		=	0
kb_f4		=	1
kb_f3		=	2
kb_f2		=	3
kb_f1		=	4
kb_2nd		=	5
kb_mode		=	6
kb_del		=	7

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; Scan codes returned by getkey
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
sk_null		=	$00	; No key pressed
sk_down		=	$01
sk_left		=	$02
sk_right	=	$03
sk_up		=	$04
; $05 - $08 not assigned
sk_enter	=	$09
sk_plus		=	$0A
sk_minus	=	$0B
sk_times	=	$0C
sk_obelus	=	$0D
sk_caret	=	$0E
sk_clear	=	$0F
; $10 not assigned
sk_chs		=	$11
sk_3		=	$12
sk_6		=	$13
sk_9		=	$14
sk_rparen	=	$15
sk_tan		=	$16
sk_vars		=	$17
; $18 not assigned
sk_point	=	$19
sk_2		=	$1A
sk_5		=	$1B
sk_8		=	$1C
sk_lparen	=	$1D
sk_cos		=	$1E
sk_prgm		=	$1F
sk_stat		=	$20
sk_0		=	$21
sk_1		=	$22
sk_4		=	$23
sk_7		=	$24
sk_comma	=	$25
sk_sin		=	$26
sk_apps		=	$27
sk_xt0n		=	$28
; $29 not assigned
sk_sto		=	$2A
sk_ln		=	$2B
sk_log		=	$2C
sk_square	=	$2D
sk_recip	=	$2E
sk_math		=	$2F
sk_alpha	=	$30
sk_graph	=	$31
sk_trace	=	$32
sk_zoom		=	$33
sk_window	=	$34
sk_yequ		=	$35
sk_2nd		=	$36
sk_mode		=	$37
sk_del		=	$38

sk_a = sk_math
sk_b = sk_apps
sk_c = sk_prgm
sk_d = sk_recip
sk_e = sk_sin
sk_f = sk_cos
sk_g = sk_tan
sk_h = sk_caret
sk_i = sk_square
sk_j = sk_comma
sk_k = sk_lparen
sk_l = sk_rparen
sk_m = sk_obelus
sk_n = sk_log
sk_o = sk_7
sk_p = sk_8
sk_q = sk_9
sk_r = sk_times
sk_s = sk_ln
sk_t = sk_4
sk_u = sk_5
sk_v = sk_6
sk_w = sk_minus
sk_x = sk_sto
sk_y = sk_1
sk_z = sk_2

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; Special getch ASCII codes
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
k_down		=	$01	; DOWN
k_left		=	$02	; LEFT
k_right		=	$03	; RIGHT
k_up		=	$04	; UP
k_xt0n		=	$05	; XT0n
k_del		=	$08	; DEL
k_enter		=	$0A	; ENTER
k_clear		=	$0C	; CLEAR
k_f1		=	$11	; F1
k_f2		=	$12	; F2
k_f3		=	$13	; F3
k_f4		=	$14	; F4
k_f5		=	$15	; F5
k_quit		=	$1B	; MODE

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; Link I/O
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

RED1_WHITE1	=	%00000000	; "1" = +5V, "0" = 0V
RED0_WHITE1	=	%00000001
RED1_WHITE0	=	%00000010
RED0_WHITE0	=	%00000011
TIMEOUT		=	300

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; Link Commands
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

; Device codes
link_PC		=	$23
link_83P	=	$73

; Command codes
link_REXT	=	$01	; Exit
link_RMEM	=	$03	; Memory
link_VAR	=	$06	; Variable header
link_CTS	=	$09	; Clear to send variable
link_DATA	=	$15	; Data packet
link_REJ	=	$36	; Rejection
link_ACK	=	$56	; Acknowledgement
link_CHK	=	$5A	; Checksum error
link_RDY	=	$68	; Check ready
link_EOT	=	$92	; End of transmission
link_REQ	=	$A2	; Request variable
link_RTS	=	$C9	; Request to send variable (silent-link)

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; Exceptions
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
E_CREATE	=	0
E_LOCATE	=	1
E_LINK		=	2
E_EXIST		=	3
E_MEMORY	=	4
E_CHECKSUM	=	5

